library(ggmap)
library(httr)
library(jsonlite)

endpoint <- "http://statistics.iotc.org/rest/services/data/ce/catch/reallocation/byArea"
api_key <- "f6ec6dd32798ea96ae552bf34201ff17"

payload = paste0(
	'{',
		'"fromYear": 2010, ',
		'"toYear": 2015, ',
		'"resolution": 2, ',
		'"includePreliminary": false, ',
		'"includeConfidential": false, ',
		'"fleets": ["TWN", "JPN", "ESP", "FRA", "SYC"], ',
		'"fisheries": ["PSFS", "PSLS", "LL", "LLSW"], ',
		'"groupByFleet": true, ',
		'"groupBySpecies": true, ',
		'"species": ["ALB", "BET", "SKJ", "SWO", "YFT"], ',
		'"unit": "MT", ',
		'"values": true',
	'}'
)

response <- POST(endpoint, 
                 accept_json(), 
                 add_headers("Content-Type" = "application/json"), 
                 add_headers("X-IOTC-STATS-API-key" = api_key), 
                 body = payload)

stop_for_status(response)
data <- fromJSON(content(response, "text"))
head(data)

map <- get_map(location = 'Sri Lanka', zoom = 3)
ggmap(map) + geom_point(aes(x = lon, y = lat, size = values), data = data, alpha = .5) + facet_grid(fleetCode ~ speciesCode)